/* (C) Copyright 1984,85,86,87 Walter L. Peacock   All Rights Reserved   */
/****************************************************************************
 *
 *   fdgets.c  --  get a string from low level file
 *
 */

#include "cbtree.h"

#ifndef EOF
#define EOF (-1)
#endif

/**************************************************************************/

char   *fdgets(buf, n, fd)   /* get a string till \n: newline NOT included ! */

/*
 *   NOTE:   programmer is responsible to make sure buffer is BIG ENOUGH!!
 *
 */
char   *buf;
int n;
int fd;
{
   extern int fdgetc();
   register int c;
   register char *s;

   s = buf;   /* must be put here for EC */
   while (n != 0 && (c = fdgetc(fd)) != EOF  &&  c != '\n')
      if (c != '\r')   /* act like ascii mode and throw out carriage returns */
      {
         *s++ = c;
         n--;
      }
   if (n != -1)
      *s = '\0';
   return (c == EOF && s == buf ? (char *)NULL : buf);
}

/********/

fdgetc(fd)   /* get char from specified low-level file */

int fd;

{
   char c;

   if (read(fd, &c, 1) == ERR)   /* assume sequential read */
      return (EOF);
   return ((int)c);
}
